{
  system,
  config,
  lib,
  pkgs,
  hyprland,
  hy3,
  ...
}:
with lib;
  mkIf (elem "desktop::hyprland" config.machine.services) {

    programs = {
      dconf.enable = true;
      hyprland = {
        enable = true;
        package = hyprland.packages."${system}".hyprland;
        xwayland.enable = false;
      };
    };
    services.xserver = {
      enable = true;
      displayManager.sddm = {
        enable = true;
        autoNumlock = true;
        wayland.enable = true;
      };
    };
    environment.systemPackages =
      [
        hy3.packages."${system}".hy3
      ]
      ++
      (with pkgs; [
        kanagawa
        eww-wayland
        rofi-wayland
        hyprpicker
        waybar
        swaybg
        gtk3
        gnome.adwaita-icon-theme
        gsettings-desktop-schemas
      ]);

    # TODO: Refactor
    environment = {
      etc."xdg/gtk-2.0/gtkrc".text = ''
        gtk-key-theme-name = "Kanagawa-BL"
      '';
      etc."xdg/gtk-3.0/settings.ini".text = ''
        [Settings]
        gtk-key-theme-name = Kanagawa-BL
      '';
      sessionVariables.NIXOS_OZONE_WL = "1";
    };
    qt = {
      enable = true;
      platformTheme = "gnome";
      style = "adwaita-dark";
    };
  }
